/*

Provides a Vue 3 component that displays a form for Guest Information that
allows editing, and submitting changes. 

Requires a GuestInfoBackend that implements GuestInfoAPI v1.0.3

Emits a guestInfoCancelEvent

*/

<template>
    <form v-on:submit.prevent="submitForm">
        <p>Number of visits this week: {{ weekData.weekly_visits }} </p>
        <p>Guest Id Number: {{ guestData.BNMID }}</p>
        <p>Is the guest a WNE on-campus resident?
            <select v-model="guestData.Resident">
                <option value="resident">Yes</option>
                <option value="commuter">No</option>
            </select>
        </p>
        <p>Is the guest a graduate or undergrad student?
            <select v-model="guestData.Grad">
                <option value="UG">Undergrad</option>
                <option value="G">Grad</option>
            </select>
        </p>
        <p>Graduating Year
            <input id="grad_year" required minlength="4" maxlength="4" v-model="guestData.Grad_Year" type="number"
                min="1919" step="1" value="1919">
        </p>
        <p>Year Issued
            <input id="year_issued" required minlength="4" maxlength="4" v-model="guestData.Year_Issued" type="number"
                min="1919" step="1" value="1919">
        </p>
        <button class="submit" @click="submitGuestData">Submit</button>
        <button class="submit" @click="cancel">Cancel</button>
    </form>
    <form v-on:submit.prevent="submitForm">
        <button class="remove" @click="removeGuestData">Remove Guest</button>
    </form>
</template>
    
<script>

import axios from 'axios';
import { BACKEND_BASE_URL } from '../env.js'

export default {
    name: 'GuestDataComponent',
    emits: [
        'guestDataCancelEvent'
    ],
    data() {
        return {
            guestData: {
                "BNMID": this.idNum,
                "Resident": "resident",
                "Grad_Year": 2025,
                "Grad": "UG",
                "Date": new Date().toLocaleDateString("en-US").replace("/", "-").replace("/", "-"),
                "Year_Issued": 2025,
            },
            existingGuest: true,
            visitData: {
                "BNMID": this.idNum,
                "Date": new Date().toLocaleDateString("en-US").replace("/", "-").replace("/", "-"),
            },
            weekData: {
                "weekly_visits": 0
            },
            error: false
        }
    },
    props: {
        idNum: String
    },
    watch: {
        idNum() {
            this.fetchGuestData();
        }
    },
    methods: {
        async fetchGuestData() {
            try {
                let guestURL = BACKEND_BASE_URL + "/guests/" + this.idNum;
                let guestResponse = await axios.get(guestURL);

                if (guestResponse.status == 200) {
                    this.guestData = guestResponse.data;
                    this.existingGuest = true;
                    console.log(this.guestData);
                    
                    let current_time = new Date();
                    let last_week_time = new Date();
                    last_week_time.setDate(last_week_time.getDate() - 7);
                    current_time = (current_time.getMonth() + 1) + "-" + current_time.getDate() + "-" + current_time.getFullYear();
                    last_week_time = (last_week_time.getMonth() + 1) + "-" + last_week_time.getDate() + "-" + last_week_time.getFullYear();
                    
                    let visitURL = BACKEND_BASE_URL + "/visits/" + last_week_time + "+" + current_time;

                    let visitResponse = await axios.get(visitURL);
                        if (visitResponse.status == 200) {
                            var count = 0;
                            for (var i = 0; i < visitResponse.data.visits.length; i++ ) {
                                if (visitResponse.data.visits[i].BNMID == this.guestData.BNMID) {
                                    count++;
                                }
                            }
                        this.weekData.weekly_visits = count;
                    }
                }
            } catch (err) {
                this.existingGuest = false;
                this.guestData.BNMID = this.idNum;
                this.submitGuestData();
                this.error = true;
                console.log(err);
            }
        },
        async submitGuestData() {

            if (this.existingGuest) {
                axios.put(BACKEND_BASE_URL + "/guests/" + this.guestData.BNMID, this.guestData)
                    .then(() => {
                        //  success - record the visit
                        this.recordVisit();
                    })
                    .catch(error => {
                        this.error = true;
                        console.log("An error has ocurred: " + error);
                        console.error(error);
                    })
            } else {
                console.log(this.guestData);
                axios.post(BACKEND_BASE_URL + "/guests/", this.guestData)
                    .then(() => {
                        this.existingGuest = true;
                        // success - add guest then record visit
                        alert("Guest added");
                        
                    })
                    .catch(error => {
                        this.error = true;
                        console.log("An error has ocurred: " + error);
                        console.error(error);
                    })
            }
        },
        // Remove Guest Information from Backend
        async removeGuestData() {
            if (this.existingGuest) {
                axios.delete(BACKEND_BASE_URL + "/guests/" + this.guestData.BNMID, this.guestData)
                    .then(() => {
                        //success - remove guest from db
                        alert("Guest Successfully removed");
                        location.reload();
                    })
                    .catch(error => {
                        this.error = true;
                        console.log("An error has ocurred: " + error);
                        console.error(error);
                    })
            }
        },
        recordVisit() {
            this.visitData.BNMID = this.guestData.BNMID;
            axios.post(BACKEND_BASE_URL + "/visits/", this.visitData)
                .then(() => {
                    //  success - do nothing
                    alert("Visit recorded.");
                    this.cancel();
                })
                .catch(error => {
                    this.error = true;
                    console.log("An error has ocurred: " + error);
                    console.error(error);
                })
        },
        cancel() {
            location.reload();
            this.$emit('guestDataCancelEvent');
        }
    }
}

</script> 

<!-- Add 'scoped' attribute to limit CSS to this component only -->
<style scoped>
form {
    margin: auto;
    max-width: 90%;
    padding: 1vh 0 1vh 0;
    text-align: left;
}

.remove {
    background: #C0392B;
}
</style>
